#ifndef CHEAPCLOCK_H
#define CHEAPCLOCK_H
#include<ace/OS_NS_time.h>
#include<ace/Time_Value.h>
#include<stdint.h>
class CheapClock
{
public:
  CheapClock()
    {
      thr2_=ACE_OS::gethrtime();
      tsys2_=ACE_OS::gettimeofday();
    }
  ACE_Time_Value gettime()
  { 
    // T=(Thr-thr2)*(tsys2-tsys1)/(thr2-thr1)+tsys2
    ACE_hrtime_t thr = ACE_OS::gethrtime();
    double current_us = (thr-thr2_)*correlationfactor_;
    uint64_t round=(uint64_t)current_us;
    ACE_Time_Value offset(round/1000000ULL,(round%1000000ULL));
    return tsys2_+offset;
  }

  void timesample(const ACE_Time_Value& sample)
  {
    //??? idee: ignorierung wenn thr2_-thr1_ < min
    tsys1_=tsys2_;
    tsys2_=sample;
    thr1_=thr2_;
    thr2_=ACE_OS::gethrtime();
    ACE_Time_Value systimediff = tsys2_-tsys1_;
    correlationfactor_= (systimediff.sec()*1000000ULL+systimediff.usec())/(double)(thr2_-thr1_);
  }
  double correlationfactor() { return correlationfactor_; }  
private:
  ACE_hrtime_t thr1_;
  ACE_hrtime_t thr2_;
  ACE_Time_Value tsys1_;
  ACE_Time_Value tsys2_;
  double correlationfactor_; // dim us/ticks
};
#endif
