#include<ace/OS_NS_time.h>
#include<ace/Time_Value.h>
#include"CheapClock.h"
#include<iostream>
#include<stdlib.h>
#include<math.h>

int main(int argc,char **argv)
{
  char **arg = argv+1;
  double fins=1.0;
  bool exprandom=false;
  if(*arg!=0)
  {
    if(strcmp(*arg,"random")==0)
    {
      exprandom=true;
    }
    else
    {
      char *e=0;
      fins=strtod(*arg,&e);
    }
  }
  double finns =fins*1E9; // ns
  struct timespec checkinterval;
  checkinterval.tv_sec = (time_t)fins;
  checkinterval.tv_nsec = (long)(finns - checkinterval.tv_sec*1E9);
  std::clog << "Intervall (s:ns)=" << checkinterval.tv_sec
            << ":" << checkinterval.tv_nsec
	    << std::endl;
  CheapClock cheapclock;
  ACE_OS::nanosleep(&checkinterval);
  ACE_hrtime_t vorgtof = ACE_OS::gethrtime();
  ACE_Time_Value currentgtofday = ACE_OS::gettimeofday();
  ACE_hrtime_t nachgtof = ACE_OS::gethrtime();
  cheapclock.timesample(currentgtofday);
  ACE_hrtime_t nachts = ACE_OS::gethrtime();
  ACE_Time_Value currentcheap = cheapclock.gettime();
  ACE_hrtime_t nachcc = ACE_OS::gethrtime();
  ACE_hrtime_t kgtof = nachgtof - vorgtof;
  ACE_hrtime_t kts   = nachts-nachgtof;
  ACE_hrtime_t kcc   = nachcc-nachts;
  std::clog << "Kosten gettimeofday = " << kgtof << " ticks" << std::endl;
  std::clog << "Kosten timesample   = " << kts << " ticks" << std::endl;
  std::clog << "kosten cheapclock   = " << kcc << " ticks" << std::endl;
  std::clog << "cheapclockinitialized ..." << std::endl;
  std::clog << "s gettimeofday\ts cheapclock\tdiff\tinvcorr" << std::endl;
  while(1)
  {
    if(exprandom)
    {
      // exponentialverteilte Zufallszeiten ab 500 ms
      double r = 500-2000*log((double)random()/(double)RAND_MAX);
      checkinterval.tv_sec = (long)r/1000;
      double rnsec=r-checkinterval.tv_sec*1000;
      checkinterval.tv_nsec = (rnsec*1000000.0);
      std::clog << "testcheckinterval = " << r << "ms "
		<< " (" << checkinterval.tv_sec
		<< ':' << checkinterval.tv_nsec
		<< ')' << std::endl;
    }
    ACE_OS::nanosleep(&checkinterval); 
    ACE_Time_Value currentcheap = cheapclock.gettime();
    currentgtofday = ACE_OS::gettimeofday();
    cheapclock.timesample(currentgtofday);
    double diff =  currentcheap.sec()*1E6+currentcheap.usec()
                   -(currentgtofday.sec()*1E6+currentgtofday.usec());
    std::cout << currentgtofday.sec() << '\t'
	      << currentcheap.sec() << "\t" << diff << "us\t"
              << cheapclock.invcorrelationfactor() << "ticks/us"
	      << std::endl;

  }
}
